"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryType = void 0;
const exists_query_1 = require("./exists.query");
const match_query_1 = require("./match.query");
const must_query_1 = require("./must.query");
const nested_query_1 = require("./nested.query");
const range_query_1 = require("./range.query");
const should_query_1 = require("./should.query");
const wildcard_query_1 = require("./wildcard.query");
const string_query_1 = require("./string.query");
const nested_should_query_1 = require("./nested.should.query");
const script_query_1 = require("./script.query");
class QueryType {
}
exports.QueryType = QueryType;
QueryType.Match = (key, value, operator = undefined) => {
    return new match_query_1.MatchQuery(key, value, operator);
};
QueryType.Exists = (key) => {
    return new exists_query_1.ExistsQuery(key);
};
QueryType.Range = (key, ...ranges) => {
    return new range_query_1.RangeQuery(key, ranges);
};
QueryType.Wildcard = (key, value) => {
    return new wildcard_query_1.WildcardQuery(key, value);
};
QueryType.Nested = (key, value) => {
    return new nested_query_1.NestedQuery(key, value);
};
QueryType.NestedShould = (key, value) => {
    return new nested_should_query_1.NestedShouldQuery(key, value);
};
QueryType.Should = (queries) => {
    return new should_query_1.ShouldQuery(queries);
};
QueryType.Must = (queries, mustNotQueries = []) => {
    return new must_query_1.MustQuery(queries, mustNotQueries);
};
QueryType.String = (key, value) => {
    return new string_query_1.StringQuery(key, value);
};
QueryType.Script = (source) => {
    return new script_query_1.ScriptQuery(source);
};
//# sourceMappingURL=query.type.js.map